/*
 *	Nero AAC GR[_o͂ iTunes M4A Ɍ
 *	^JukeboxɃC|[gł悤ɂvO
 *
 *	naa22m4a ver1.1	 Copyright (c) N099 2007,2009
 *
 *
 *	Ql
 *	1:Inside: QuickTime
 *	  http://www.geocities.com/xhelmboyx/quicktime/
 *	2:QuickTime File Format
 *	  http://developer.apple.com/documentation/QuickTime/QTFF/qtff.pdf
 *	3:3GPP TS 26.244 V7.0.0
 *	  Transparent end-to-end packet switched streaming service (PSS); 3GPP file format (3GP)
 *	  http://www.3gpp.org/ftp/Specs/html-info/26244.htm
 *	4:Bento4 MP4 Class Library/SDK
 *	  http://bento4.sourceforge.net
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

static void print_usage(const char *name);
static FILE *get_fp(const char *name, int ow);
static unsigned long read32be(unsigned char b[4]);
static int change_ftyp(FILE *fp, int write);
static int change_br(FILE *fp, int br, int write);
static int search_leaf_atom(FILE *fp, const unsigned char id[4]);
static int change_esds(unsigned char *data, int size, int br);

/* o̓t@C */
static char *outname = NULL;
static size_t sz_outname = 0;

void print_usage(const char *name)
{
	printf("Usage:%s [-w] [-b br] file1 [file2 [...]]\n", name);
	printf("Options\n-w : overwrite input files.\n");
	printf("-b br : set bitrate to 'br' kbps.\n");
}

int main(int argc, char *argv[])
{
	int i,fnum;
	int ow = 0;
	int br = 0;
	char **fname = NULL;

	if(1 == argc){
		print_usage(argv[0]);
		return 0;
	}

	for(i=1; i<argc; ++i){
		if(argv[i][0] == '-'){
			if(argv[i][1] == 'w'){
				/*㏑[h*/
				ow = 1;
			}
			if(argv[i][1] == 'b' || argv[i][2] == 'b'){
				if(++i >= argc) break;
				/*rbg[g*/
				br = atoi(argv[i]);
			}
		}else{
			fnum = argc - i;
			fname = &argv[i];
			break;
		}
	}

	/* no input file or invalid bitrate */
	if(fname == NULL || br < 0 || br > 8192){
		print_usage(argv[0]);
		return -1;
	}

	/* main loop */
	for(i=0; i<fnum; ++i){
		FILE *fp;
		int err = 1;

		/* ̓t@C̃`FbN */
		fp = fopen(*fname, "rb");
		if(fp){
			if(change_ftyp(fp, 0)){
				; /* NG */
			}else if(change_br(fp, br, 0)){
				; /* NG */
			}else{
				/* OK */
				err = 0;
			}
			fclose(fp);
		}
		if(err){
			fprintf(stderr, " Skipped:%s\n", *fname);
			fname++;
			continue;
		}

		/* o̓t@C̏ */
		fp = get_fp(*fname, ow);
		if(!fp){
			fprintf(stderr, "Skipped:%s\n", *fname);
			fname++;
			continue;
		}

		if(change_ftyp(fp, 1)){
			fprintf(stderr, " Skipped File:%s\n", *fname);
			err = 1;
		}else if(change_br(fp, br, 1)){
			fprintf(stderr, " Skipped File:%s\n", *fname);
			err = 1;
		}
		fclose(fp);

		/* G[t@C̍폜/l[ */
		if(ow){
			if(!err && outname){
				//printf("i:%s\no:%s\n", *fname, outname);
				rename(*fname, outname);
			}
		}else if(err && outname){
			//printf("i:%s\no:%s\n", *fname, outname);
			remove(outname);
		}

		fname++;
	}

	free(outname);
	return 0;
}

/* t@C̎擾 */
FILE *get_fp(const char *name, int ow)
{
	FILE *ifp,*ofp;
	size_t n_len;
	int k;
	char *ext;

	/* Rs[il[jt@C̍쐬 */
	n_len = strlen(name) + 1 + 2; /* \0 + xx */
	if(n_len > sz_outname){
		sz_outname = n_len * 2;
		outname = realloc(outname, sz_outname);
	}
	if(!outname){
		fprintf(stderr, "malloc failed!");
		return NULL;
	}
	strncpy(outname, name, n_len-2);
	ext = strrchr(outname, '.');
	if(NULL==ext){
		fprintf(stderr, "input file:%s extension error!", outname);
		return NULL;
	}else if(strlen(ext) < 4){
		fprintf(stderr, "input file:%s extension error!", outname);
		return NULL;
	}

	/* ".m4a"̒ǉ */
	/** gq".m4a"̂ݎ󂯕tHiC|[gj **/
	memcpy(ext, ".m4a", sizeof(".m4a"));
		
	/* t@C̏Փ˃`FbN*/
	for(k=0; k<100; ++k){
		char sf[8];
		ofp = fopen(outname, "r");
		if(ofp){
			fclose(ofp);

			/* "xx.m4a"̒ǉ */
			sprintf(sf, "%02d.m4a", k);
			memcpy(ext, sf, strlen(sf)+1);
		}else{
			break;
		}
	}
	if(k==100){
		fprintf(stderr, "output file: create failed!");
		return NULL;
	}


	/* ㏑ȂƂ͂܂t@CRs[ */
	if(ow){
		ofp = fopen(name, "r+b");
		if(!ofp){
			fprintf(stderr, "file:%s open failed!", name);
			return NULL;
		}
	}else{
		char buf[BUFSIZ];

		/* t@CI[v{쐬 */
		ifp = fopen(name, "rb");
		if(!ifp){
			fprintf(stderr, "input file:%s open failed!", name);
			return NULL;
		}
		ofp = fopen(outname, "w+b");
		if(!ofp){
			fprintf(stderr, "output file:%s open failed!", outname);
			fclose(ifp);
			return NULL;
		}

		/* f[^̃Rs[ */
		do{
			n_len = fread(buf, 1, sizeof(buf), ifp);
			if(n_len != fwrite(buf, 1, n_len, ofp)){
				fprintf(stderr, "copy failed!");
				fclose(ifp);
				fclose(ofp);
				return NULL;
			}
		}while(n_len == sizeof(buf));
		fclose(ifp);
		rewind(ofp);
	}

	return ofp;
}

/* GfBAւ */
unsigned long read32be(unsigned char b[4])
{
	int c;

	c  = b[0] << 24;
	c |= b[1] << 16;
	c |= b[2] << 8;
	c |= b[3];

	return c;
}

/* "ftyp" BOX ̏ */
static int change_ftyp(FILE *fp, int write)
{
	size_t size,size_r;
	const unsigned char ft[4]	   = {'f', 't', 'y', 'p'};
	const unsigned char ft_3gp6[4] = {'3', 'g', 'p', '6'};
	const unsigned char ft_mp42[4] = {'m', 'p', '4', '2'};
	const unsigned char ft_M4A_[4] = {'M', '4', 'A', ' '};
	const unsigned char ft_ndam[4] = {'n', 'd', 'a', 'm'};
	const unsigned char ft_ndia[4] = {'n', 'd', 'i', 'a'};
	unsigned char buf[8];
	unsigned char *box;
	int i,j,n_ent = 0;
	fpos_t pos,pos2;

	size_r = fread(buf, 1, sizeof(buf), fp);
	if(size_r != sizeof(buf)){
		fprintf(stderr, "format error!(size)");
		return -1;
	}else if(0 != memcmp(ft, &buf[4], sizeof(ft))){
		fprintf(stderr, "format error!(ftyp)");
		return -1;
	}

	/* read box */
	size = read32be(buf) - sizeof(buf);
	box = malloc(size);
	if(!box){
		fprintf(stderr, "error!(malloc)");
		return -2;
	}
	fgetpos(fp, &pos);
	size_r = fread(box, 1, size, fp);
	if(size_r != size){
		fprintf(stderr, "error!(rd box)");
		free(box);
		return -1;
	}
	fgetpos(fp, &pos2);

	/* type check*/
	if(0 != memcmp(ft_3gp6, box, sizeof(ft_3gp6))
		&& 0 != memcmp(ft_mp42, box, sizeof(ft_mp42)))
	{
		fprintf(stderr, "format error!(ftyp main)");
		free(box);
		return -1;
	}else{
		/* change main type */
		/** "M4A "łȂƎ󂯕tȂH **/
		memcpy(box, ft_M4A_, sizeof(ft_M4A_));
	}

	/* `FbN̂ */
	if(!write){
		free(box);
		return 0;
	}

	/* compatible brands */
	/** ͕ύXȂĂvH **/
	n_ent = (size/4) - 2;
	for(i=0; i<n_ent; ++i){
		/* "M4A "łɑ݂ꍇ͏Ȃ */
		if(0 == memcmp(ft_M4A_, &box[8 + i*4], sizeof(ft_M4A_))){
			n_ent = 0;
			break;
		}
	}
	for(i=0; i<n_ent; ++i){
		if(0 == memcmp(ft_ndam, &box[8 + i*4], sizeof(ft_ndam))
			|| 0 == memcmp(ft_ndia, &box[8 + i*4], sizeof(ft_ndia)))
		{
			for(j=i; j>0; --j){
				memcpy(&box[8 + j*4], &box[8 - 4 + j*4], 4);
			}
			memcpy(box+8, ft_M4A_, sizeof(ft_M4A_));
			break;
		}
	}

	/* write back */
	fsetpos(fp, &pos);
	size_r = fwrite(box, 1, size, fp);
	free(box);

	fsetpos(fp, &pos2);
	return (size == size_r) ? 0 : -2;
}

/* rbg[g̕ύX */
static int change_br(FILE *fp, int br, int write)
{
	int size,size2;
	const unsigned char moov[4] = {'m', 'o', 'o', 'v'};
	const unsigned char trak[4] = {'t', 'r', 'a', 'k'};
	const unsigned char mdia[4] = {'m', 'd', 'i', 'a'};
	const unsigned char minf[4] = {'m', 'i', 'n', 'f'};
	const unsigned char stbl[4] = {'s', 't', 'b', 'l'};
	const unsigned char stsd[4] = {'s', 't', 's', 'd'};
	const unsigned char mp4a[4] = {'m', 'p', '4', 'a'};
	unsigned char buf[8];
	unsigned char *box;
	fpos_t pos;

	/* search "moov" Atom */
	if(search_leaf_atom(fp, moov) < 0){
		fprintf(stderr, "format error(moov)");
		return -1;
	}
	/* search "trak" Atom */
	if(search_leaf_atom(fp, trak) < 0){
		fprintf(stderr, "format error(trak)");
		return -1;
	}
	/* search "mdia" Atom */
	if(search_leaf_atom(fp, mdia) < 0){
		fprintf(stderr, "format error(mdia)");
		return -1;
	}
	/* search "minf" Atom */
	if(search_leaf_atom(fp, minf) < 0){
		fprintf(stderr, "format error(minf)");
		return -1;
	}
	/* search "stbl" Atom */
	if(search_leaf_atom(fp, stbl) < 0){
		fprintf(stderr, "format error(stbl)");
		return -1;
	}
	/* search "stsd" Atom */
	if(search_leaf_atom(fp, stsd) < 0){
		fprintf(stderr, "format error(stsd)");
		return -1;
	}

	/* test sample description box */
	size = fread(buf, 1, sizeof(buf), fp);
	if(0 != read32be(buf) || 1 != read32be(&buf[4])){
		fprintf(stderr, "format error(stsd #1)");
		return -1;
	}

	/* check audio format */
	size = search_leaf_atom(fp, mp4a);
	if(size < 0){
		fprintf(stderr, "format error(mp4a)");
		return -1;
	}
	box = malloc(size + 128); /* for safety */
	if(!box){
		fprintf(stderr, "error!(malloc)");
		return -2;
	}

	/* change bitrate */
	fgetpos(fp, &pos);
	size2 = fread(box, 1, size, fp);
	if(size2 != size){
		fprintf(stderr, "error!(rd box)");
		free(box);
		return -1;
	}

	if(change_esds(box, size, br)){
		fprintf(stderr, "format error(esds)");
		free(box);
		return -1;
	}

	/* `FbN̂ */
	if(!write){
		free(box);
		return 0;
	}

	fsetpos(fp, &pos);
	size2 = fwrite(box, 1, size, fp);

	free(box);
	return (size == size2) ? 0 : -3;
}

/* serch child box */
static int search_leaf_atom(FILE *fp, const unsigned char id[4])
{
	size_t size;
	unsigned char buf[8];
	int loop = 1;

	/* search leaf Atom */
	while(loop){
		size = fread(buf, 1, sizeof(buf), fp);
		if(size != sizeof(buf) || feof(fp) || ferror(fp)){
			return -1;
		}else if(0 == memcmp(id, &buf[4], sizeof(id))){
			loop = 0;
		}else{
			long offs = read32be(buf) - sizeof(buf);
			if(offs<0){
				return -1;
			}
			fseek(fp, offs, SEEK_CUR);
		}
	}

	return (int)(read32be(buf) - sizeof(buf));
}

/* change avr/max rate */
static int change_esds(unsigned char *data, int size, int br)
{
	unsigned long nb;
	const unsigned char esds[4] = {'e', 's', 'd', 's'};
	unsigned char *esd = data + 28; /* ESDBox offset */
	unsigned char *ddc; /* decoder config descriptor container pos */

	size -= 28; /* ES Descriptor box size */

	if(read32be(esd) != size || memcmp(esds, esd + 4, sizeof(esds))){
		return -1;
	}

	/* search decoder config descriptor*/
	ddc = esd + 4 + 4 + 4; /* ES descriptor type tag */
	if(*ddc++ != 0x3){
		return -1;
	}
	if(*ddc & 0x80){
		ddc += 3;
	}
	ddc += 1 + 2 + 1; /* decoder config descriptor type tag */
	if(*ddc++ != 0x4){
		return -1;
	}
	if(*ddc & 0x80){
		ddc += 3;
	}
	ddc++; /* length */

	/* check object type ID(MPEG-4 audio == 64) */
	if(*ddc != 64U){
		return -1;
	}

	/* new bitrate */
	nb = read32be(ddc+9); /* average bitrate */

	/* set new rate */
	if(br > 0){
		nb = br * 1000;
	}else{
		nb = 1000 * ((nb + 499)/1000);
	}
	nb = read32be((char*)&nb);

	/* set new bitrate */
	/** max == avr łȂƂ߁H **/
	memcpy(ddc+5, &nb, 4); /* maximum bitrate */
	memcpy(ddc+9, &nb, 4); /* average bitrate */

	return 0;
}

